<template>
    <f7-page name="accounthistories" 
        @page:beforein="onPageBeforeIn"
        @page:beforeout="onPageBeforeOut"
        ptr 
        @ptr:refresh="onPageRefresh"
        infinite
        :infinite-distance="50"
        :infinite-preloader="showPreloader"
        @infinite="loadMore">
		<!-- Top Navbar -->
		<f7-navbar :sliding="false">
            <f7-nav-left back-link></f7-nav-left>
            <f7-nav-title>My Histories</f7-nav-title>
		</f7-navbar>

        <f7-block v-if="histories.length > 0">
            <ul class="timeline">
                <li 
                    class="timeline-item"
                    v-for="(history, index) in histories"
                    :key="index"
                    >
                    <div class="timeline-item-tail"></div>
                    <div class="timeline-item-node timeline-item-node-normal"></div>
                    <div class="timeline-item-wrapper">
                        <div class="timeline-timestamp">{{ dateFormat(history.created) }}</div>
                        <div class="timeline-item-content">
                            <h4>{{ history.user.fullname }} - {{ history.action }} {{ history.module }}</h4>
                            <p>{{ history.user_agent.os.family }} {{ history.user_agent.os.major }} {{ history.user_agent.user_agent.family }} - {{ history.remote_address }}</p>
                        </div>
                    </div>
                </li>
            </ul>
        </f7-block>
    </f7-page>
</template>
<script>
import { mapGetters } from 'vuex';
import { dateFormat } from '../js/utils';
export default {
    name: 'AccountHistories',
    data(){
        return {
            allowInfinite: true,
            showPreloader: true,
        };
    },
    computed: {
        ...mapGetters('auth', ['user']),
        ...mapGetters('history', [
            'histories',
            'pagination'
        ])
    },
    methods: {
        dateFormat,
        getHistories(page, loadmore){
            const self = this;
            const app = self.$f7;

            app.preloader.show('red');

            self.$store.dispatch('history/getHistories', {
                user: self.user.id,
                page: page,
                perpage: 25,
                loadmore: loadmore,
                only: 'action,content,module,remote_address,created,user.fullname,user_agent'
            }).then(()=>{
                setTimeout(()=>{
                    app.preloader.hide();
                    self.showPreloader = self.pagination.has_next;
                }, 100);
            });
        },
        onPageBeforeIn(){
            const self = this;
            const app = self.$f7;
            const $ = self.$$;

            self.getHistories(1, false);
        },
        onPageBeforeOut(){
            const self = this;
            const app = self.$f7;
        },
        onPageRefresh(e, done){
			const self = this;
            self.productLoading = true;

            self.$store.dispatch('history/resetHistories');

			self.getHistories(1, false);

			done();
		},
		loadMore(){
			const self = this;

			if (!self.allowInfinite) return;
			self.allowInfinite = false;
			setTimeout(()=>{
				if(self.pagination.has_next){                
					self.getHistories(self.pagination.page + 1, true);
					self.allowInfinite = true;
				}else{
					self.showPreloader = false;
				}
			}, 1000);
        },
        
    },

}
</script>
